# -*- coding: utf-8 -*-
# Generated by Django 1.9.7 on 2016-06-13 22:20
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('timeside_server', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='AnalysisTrack',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_public', models.BooleanField(default=True)),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='analysistrack', to=settings.AUTH_USER_MODEL, verbose_name='author')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubProcessor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('sub_processor_id', models.CharField(max_length=128, unique=True, verbose_name='sub_processor_id')),
            ],
        ),
        migrations.AddField(
            model_name='item',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AddField(
            model_name='processor',
            name='name',
            field=models.CharField(blank=True, max_length=256, verbose_name='name'),
        ),
        migrations.AddField(
            model_name='result',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AddField(
            model_name='selection',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AddField(
            model_name='task',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AlterField(
            model_name='experience',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='experience', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AlterField(
            model_name='experience',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AlterField(
            model_name='item',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='item', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AlterField(
            model_name='preset',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='preset', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AlterField(
            model_name='preset',
            name='is_public',
            field=models.BooleanField(default=True),
        ),
        migrations.AlterField(
            model_name='processor',
            name='pid',
            field=models.CharField(choices=[(b'Analyzers', [(b'vamp_simple_host', b'vamp_simple_host'), (b'aubio_melenergy', b'aubio_melenergy'), (b'aubio_mfcc', b'aubio_mfcc'), (b'aubio_pitch', b'aubio_pitch'), (b'aubio_specdesc', b'aubio_specdesc'), (b'aubio_temporal', b'aubio_temporal'), (b'yaafe', b'yaafe'), (b'spectrogram_analyzer', b'spectrogram_analyzer'), (b'onset_detection_function', b'onset_detection_function'), (b'spectrogram_analyzer_buffer', b'spectrogram_analyzer_buffer'), (b'tempogram', b'tempogram'), (b'waveform_analyzer', b'waveform_analyzer'), (b'mean_dc_shift', b'mean_dc_shift'), (b'level', b'level')]), (b'Graphers', [(b'grapher_aubio_pitch', b'grapher_aubio_pitch'), (b'grapher_onset_detection_function', b'grapher_onset_detection_function'), (b'grapher_tempogram', b'grapher_tempogram'), (b'grapher_waveform', b'grapher_waveform'), (b'spectrogram_log', b'spectrogram_log'), (b'spectrogram_lin', b'spectrogram_lin'), (b'waveform_simple', b'waveform_simple'), (b'waveform_centroid', b'waveform_centroid'), (b'waveform_contour_black', b'waveform_contour_black'), (b'waveform_contour_white', b'waveform_contour_white'), (b'waveform_transparent', b'waveform_transparent')]), (b'Encoders', [(b'live_encoder', b'live_encoder'), (b'flac_encoder', b'flac_encoder'), (b'aac_encoder', b'aac_encoder'), (b'mp3_encoder', b'mp3_encoder'), (b'vorbis_encoder', b'vorbis_encoder'), (b'opus_encoder', b'opus_encoder'), (b'wav_encoder', b'wav_encoder'), (b'webm_encoder', b'webm_encoder')])], max_length=128, unique=True, verbose_name='pid'),
        ),
        migrations.AlterField(
            model_name='result',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='result', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AlterField(
            model_name='selection',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='selection', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AlterField(
            model_name='task',
            name='author',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='task', to=settings.AUTH_USER_MODEL, verbose_name='author'),
        ),
        migrations.AddField(
            model_name='subprocessor',
            name='processor',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='sub_results', to='timeside_server.Processor', verbose_name='processor'),
        ),
        migrations.AddField(
            model_name='analysistrack',
            name='preset',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='analysis_tracks', to='timeside_server.Preset', verbose_name='preset'),
        ),
        migrations.AddField(
            model_name='analysistrack',
            name='sub_processor_id',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='analysis_tracks', to='timeside_server.SubProcessor', verbose_name='sub_processor'),
        ),
    ]
