# -*- coding: utf-8 -*-
# Generated by Django 1.9.7 on 2016-09-26 13:29
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('timeside_server', '0008_auto_20160913_1014'),
    ]

    operations = [
        migrations.CreateModel(
            name='Annotation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_added', models.DateTimeField(auto_now_add=True, null=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, null=True, verbose_name='date modified')),
                ('uuid', models.CharField(blank=True, max_length=255, unique=True, verbose_name='uuid')),
                ('title', models.CharField(blank=True, max_length=512, verbose_name='title')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('start_time', models.FloatField(default=0, verbose_name='start time (s)')),
                ('stop_time', models.FloatField(verbose_name='stop time (s)')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='AnnotationTrack',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date_added', models.DateTimeField(auto_now_add=True, null=True, verbose_name='date added')),
                ('date_modified', models.DateTimeField(auto_now=True, null=True, verbose_name='date modified')),
                ('uuid', models.CharField(blank=True, max_length=255, unique=True, verbose_name='uuid')),
                ('title', models.CharField(blank=True, max_length=512, verbose_name='title')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('is_public', models.BooleanField(default=True)),
                ('overlapping', models.BooleanField(default=False)),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='annotationtrack', to=settings.AUTH_USER_MODEL, verbose_name='author')),
                ('item', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='annotation_tracks', to='timeside_server.Item', verbose_name='item')),
            ],
            options={
                'db_table': 'timeside_annotation_tracks',
                'verbose_name': 'Annotation Track',
            },
        ),
        migrations.AddField(
            model_name='annotation',
            name='track',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='track', to='timeside_server.AnnotationTrack', verbose_name='track'),
        ),
    ]
